/*
 * generatedatafiles.cxx
 *  Created on: Mar 24, 2011
 *      Author: Maria A. Zuluaga
 */

#include "generatedatafiles.h"

int main( int argc, char *argv[] )
{
	bool help = false;
	std::string file_in;
	std::string file_out;
	int mode = -1;
	int feats = -1, samples = -1;
	int header = 0;


	int error = 0;
	const int EXIT_OK = error++;
	const int ARG_ERROR = error++;

	vtksys::CommandLineArguments arg;
	arg.AddBooleanArgument("--help", &help, "Give this output");
	arg.AddArgument("--mode", vtksys::CommandLineArguments::SPACE_ARGUMENT,
						&mode, "0: positive file \n "
								"\t\t 1: unlabeled file \n");
	arg.AddArgument("--infile", vtksys::CommandLineArguments::SPACE_ARGUMENT,
					&file_in, "Input file");
	arg.AddArgument("--outfile", vtksys::CommandLineArguments::SPACE_ARGUMENT,
					&file_out, "Output file");
	arg.AddArgument("--header", vtksys::CommandLineArguments::SPACE_ARGUMENT,
								&header, "Header lines in input file");

	arg.Initialize(argc, argv);

	int result = 0;
	if (!(result = arg.Parse()) || help)
	{
		if (!result)
			std::cerr << "Error: problem parsing arguments" << std::endl;
		usage(arg.GetHelp(), ARG_ERROR);
	}

	if (file_out == "" || file_in == "")
	{
		std::cerr << "Error: missing required arguments" << std::endl;
		usage(arg.GetHelp(), ARG_ERROR);
	}

	if (mode == 0)
	{
		dld::DataFileGenerator::processfile(file_in,file_out,"+1",header);
	}
	else
	{
		dld::DataFileGenerator::processfile(file_in,file_out,"-1",header);
	}

	return EXIT_OK;
}

void usage(const char *help, const int error)
{
	std::cerr << "Usage: generatedatafiles [args]" << std::endl;
	std::cerr << help;
	exit(error);
}

