/*
 * dldDataFileGenerator.cxx
 *
 *  Created on: Apr 10, 2011
 *      Author: Maria A. Zuluaga
 */

#include "dldDataFileGenerator.h"

namespace dld
{

/************************ processfile ***********************************/
void DataFileGenerator::processfile(const std::string infile,
		const std::string outfile,
			const std::string label, int header, bool normalize)
{
	std::map< int, std::vector<std::string> > amap = FileReader::
			loadMatrixFromFile(infile,header);

	for (unsigned int i = 0; i < amap.size(); ++i)
	{
		std::vector<std::string> list = amap[i];
		if (!normalize)
		{
			std::vector<std::string>::iterator it = list.begin();
			list.insert ( it , label );
			FileWriter::writeStringVectorLineToFile(outfile,list,
								(i != 0),true);
		}
		else
		{
			std::cout << "Normalization functionality is absent"
					<< std::endl;
		}

	}

}

/************************ generateMuFile ***********************************/
void DataFileGenerator::generateMuFile(const std::string infile,
		const unsigned int feats, const unsigned int samples)
{
	vtkMath::RandomSeed(time(NULL));
	for (unsigned int r = 0; r < samples; ++r)
	{
		std::vector<double>sampleline;
		sampleline.push_back(-1);
		for(unsigned int f = 0; f < feats; f++)
			sampleline.push_back(vtkMath::Random(0.0,1.0));

		FileWriter::writeVectorLineToFile<double>(infile,sampleline,
					( r!= 0 ),true,true);

	}
}
} //end namespace
