/*
 * dldDataFileGenerator.h
 *
 *  Created on: Apr 10, 2011
 *      Author: zuluaga
 */

#ifndef DLDDATAFILEGENERATOR_H_
#define DLDDATAFILEGENERATOR_H_

#include "dldFileWriter.h"
#include "dldFileReader.h"

#include <vtkMath.h>
#include <string>
#include <map>

namespace dld
{
class DataFileGenerator
{
public:
	/**
	 * Reads data from a cvs file, adding up a particular label and giving
	 * LIBSVM format.
	 */
	static void processfile(const std::string infile, const std::string outfile,
			const std::string label, int header, bool normalize = false);

	/**
	 * Generates a uniform distribution for a number of samples containg
	 * a particular number of features.
	 */
	static void generateMuFile(const std::string infile, const unsigned int feats,
			const unsigned int samples);
};
}
#endif /* DLDDATAFILEGENERATOR_H_ */
