/*
 * dldPredict.h
 *
 */

#include "dldFileReader.h"

#include <string>

#include "stdio.h"
#include "stdlib.h"

namespace dld
{
class Predictor
{
public:
	/** Default constructor **/
	Predictor();

	/** Assigns the training file **/
	void setTestFile(std::string tf) { testFile = tf; }

	/** Assigns the training file **/
	void setTestPath(std::string tf) { testPath = tf + "/svm-predict"; }

	/** Predict command
	 *  \param model Evaluated model file
	 *  \param output Output file
	 **/
	void predict(std::string model, std::string output);

private:

	/** Base path for libSVM **/
	std::string testPath;
	/** Test (PU) file to classify **/
	std::string testFile;
};

}
