/*
 * dldTrainer.cxx
 *
 */

#include "dldTrainer.h"

namespace dld
{

/********************* constructor *****************************/
Trainer::Trainer()
{
	trainFile = "";
	trainPath = "";
}

/*********************** train **********************************/
void Trainer::train(std::string model, float c_val, float w_one,
		float w_two, float gamma, float degree, float coef)
{
	std::string params_str = " -q";

	if (c_val != -1)
		params_str += " -c " + Utils::to_string<float>(c_val);

	if (w_one != -1)
		params_str += " -w1 " + Utils::to_string<float>(w_one);

	if (w_two != -1)
		params_str += " -w-1 " + Utils::to_string<float>(w_two);

	if (gamma != -1)
		params_str += " -g " + Utils::to_string<float>(gamma);


	if (trainFile != "")
	{
		std::string command = trainPath + params_str + " " + trainFile
				+ " " + model;
		system(command.c_str());
	}
	else
		std::cerr << "Aborted: No training file given" << std::endl;
}

}
