/*
 * dldTrain.h
 *
 */

#ifndef DLDTRAIN_H_
#define DLDTRAIN_H_

#include <string>
#include <iostream>

#include "stdio.h"
#include "stdlib.h"

#include "dldUtils.h"
#include "dldFileReader.h"



namespace dld
{
/**
 * \class Trainer
 * Performs training by calling lib-svm interface in c.
 */
class Trainer
{
public:
	/** Default constructor **/
	Trainer();

	/** Assigns the training file **/
	void setTrainFile(std::string tf) { trainFile = tf; }
	/** Assigns the training file **/
	void setTrainPath(std::string tp) { trainPath = tp + "/svm-train"; }

	/** Train command
	 *  \param model Desired model file
	 *  \param c_val C param
	 *  \param w_one class 1 weight
	 *  \param w_two class -1 weight
	 *  \param gamma sigma value of the RBF gaussian kernel
	 *  \param degree unused. For future extension
	 *  \param coef Unused. For future extension
	 **/
	void train(std::string model, float c_val = -1, float w_one = -1,
			float w_two = -1, float gamma = -1, float degree = -1,
			float coef = -1);

private:

	/** Base path for libSVM **/
	std::string trainPath;
	/** Input data (PU) for training **/
	std::string trainFile;


};

}

#endif /* DLDTRAIN_H_ */
