/*
 * dldFileReader.cxx
 *
 */

#include "dldFileReader.h"

namespace dld{

/********************* countLines ********************************/
unsigned long FileReader::countLines(const std::string filename)
{
	unsigned long counter = 0;
	std::ifstream file;
	std::string line;
	file.open( filename.c_str() );
	if(file.is_open())
	{
		while(!file.eof())
		{
			std::getline(file,line);
			++counter;
		}
	}
	file.close();
	return counter;
}

/********************* fileExists ********************************/
bool FileReader::fileExists(std::string path)
{
	std::ifstream inp;
	inp.open(path.c_str(), std::ifstream::in);
	inp.close();
	return !inp.fail();
}

/********************* loadMatrixFromFile ********************************/
std::map< int, std::vector<std::string> >
		FileReader::loadMatrixFromFile( const std::string filename, int header)
{
	std::map< int, std::vector<std::string> > v;

	std::ifstream file;
	std::string line;
	std::string token = ";";
	file.open( filename.c_str() );
	if(file.is_open())
	{
		unsigned int linecounter = 0;
		while(!file.eof())
		{
			while (linecounter < header)
			{
				std::getline(file,line);
				linecounter++;
			}

			std::getline(file,line); //Find the token from file
			if (linecounter == header)
			{
				std::size_t found =line.find(";");
				if (found ==std::string::npos) //try a ,
				{
					found = line.find(",");
					if (found !=std::string::npos)
						token = ",";		//nothing found will go with space
				}
				else
					token = ";";
			}

			if (line.size() > 0)
			{
				std::vector<std::string> data;
				dld::Utils::tokenize(line,data,token);
				v.insert( std::pair< int, std::vector<std::string> >(
						linecounter-header,data) );
			}
			linecounter++;
		}
	}
	file.close();

	return v;
}



/********************* loadVectorFromFile ********************************/
/*std::vector<float> FileReader::loadVectorFromFile(const std::string filename)
{
	std::vector<float> v;
	std::ifstream file;
	std::string line;

	file.open( filename.c_str() );
	if(file.is_open())
	{
		while(!file.eof())
		{
			std::getline(file,line);
			if (line.size() > 0)
				v.push_back(atof(line.c_str()));
		}
	}
	file.close();

	return v;
}
*/

}

