/*
 * dldFileReader.h
 *
 */

#ifndef DLDFILEREADER_H_
#define DLDFILEREADER_H_

#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include <map>

#include "stdlib.h"

#include "dldUtils.h"

namespace dld
{
class FileReader
{
public:

	static unsigned long countLines(const std::string filename);
	static bool fileExists(std::string path);

	template <typename T>
		static std::vector<T> loadVectorFromFile(const std::string filename);

	static std::map< int, std::vector<std::string> > loadMatrixFromFile(
			const std::string filename, int header);

};

template <typename T>
std::vector<T> FileReader::loadVectorFromFile(const std::string
		filename)
{
	std::vector<T> v;
	std::ifstream file;
	std::string line;

	file.open( filename.c_str() );
	if(file.is_open())
	{
		while(!file.eof())
		{
			std::getline(file,line);
			if (line.size() > 0)
				v.push_back(atof(line.c_str()));
		}
	}
	file.close();
	return v;
}


}

#endif /* DLDFILEREADER_H_ */
