/*
 * dldFileWriter.cxx
 *
 */

#include "dldFileWriter.h"

namespace dld
{

/************************* merge *************************************/
void FileWriter::mergeFiles(const std::string fileone, const std::string filetwo,
		const std::string output)
{
	std::ifstream file_one, file_two;
	std::ofstream file_out;
	std::string line;

	file_one.open( fileone.c_str() );
	file_out.open( output.c_str() );
	if(file_one.is_open() && file_out.is_open())
	{
		while(!file_one.eof())
		{
			std::getline(file_one,line);
			if (line.size() > 0)
				file_out << line << std::endl;
		}
	}
	file_one.close();

	file_two.open( filetwo.c_str() );
	if(file_two.is_open() && file_out.is_open())
	{
		while(!file_two.eof())
		{
			std::getline(file_two,line);
			if (line.size() > 0)
				file_out << line << std::endl;
		}
	}

	file_two.close();
	file_out.close();
}

/************************* delete *************************************/
void FileWriter::deleteFile(const std::string filename)
{
	int val = remove( filename.c_str() );

	if (val != 0)
		std::cerr << "Warning: Unable to remove " << filename << std::endl;
}

/************************* writeStringVectorLineToFile ******************/
void FileWriter::writeStringVectorLineToFile(const std::string filename,
			const std::vector<std::string> v, bool append, bool count)
{
	std::ofstream file;

	if (append)
	{
		file.open( filename.c_str(), std::ios::app );
	}
	else
	{
		file.open( filename.c_str() );
	}


	for (unsigned int i = 0; i < v.size(); ++i)
	{
		if (i == 0)
			file << v[i] << " ";
		if (count && i != 0)
			file << i << ":"  << v[i] << " ";
	}
	file << std::endl;
	file.close();
}

/************************* writeVectorToFile ****************************/
/*template<class T>
void FileWriter::writeVectorToFile(const std::string filename,
			const std::vector<T> v)
{
	std::ofstream file;

	file.open( filename.c_str() );

	for (unsigned int i = 0; i < v.size(); ++i)
	{
		file << v[i] << std::endl;
	}

	file.close();
}*/

/************************* writeVectorToFile ****************************/
/*template<class T>
void FileWriter::writeVectorLineToFile(const std::string filename,
			const std::vector<T> v, bool append, bool count,
			bool firstislabel)
{
	std::ofstream file;

	if (append)
	{
		file.open( filename.c_str(), std::ios::app );
	}
	else
	{
		file.open( filename.c_str() );
	}


	for (unsigned int i = 0; i < v.size(); ++i)
	{
		if (firstislabel && i == 0)
		{
			if (v[0] == 1)
				file << "+" << v[0] << " ";
		}
		else if (count && i != 0)
			file << i << ":" << v[i] << " ";
		else
			file << v[i];
	}
    std::cout << std::endl;
	file.close();
}*/
}
