/*
 * dldUtils.h
 *
 */

#ifndef DLDUTILS_H_
#define DLDUTILS_H_

#include <string>
#include <sstream>
#include <vector>

namespace dld
{
class Utils //TODO: Templated class
{
public:
	/** Converts a float into a string **/
	template <typename T>
	static std::string to_string(const T& val);

	template<typename T>
	static bool valueOf(const std::string &s, T &obj);

	static void tokenize(const std::string& str,
			std::vector<std::string>& tokens,
	                      const std::string& delimiters = " ");
};


/**************************** to_string ************************************/
template <typename T>
std::string Utils::to_string(const T& val)
{
	std::stringstream cs;
	cs << val;

	return cs.str();
}

/**************************** valueOf ************************************/
template<typename T>
bool Utils::valueOf(const std::string &s, T &obj)
{
  std::istringstream is(s);
  return is >> obj;
}

} //end namespace
#endif /* DLDUTILS_H_ */
